diff -ruN ../nakedmudv3.7/lib/pymodules/cmd_comm.py lib/pymodules/cmd_comm.py
--- ../nakedmudv3.7/lib/pymodules/cmd_comm.py	2008-05-31 00:18:11.000000000 -0400
+++ lib/pymodules/cmd_comm.py	2009-03-02 01:43:35.000000000 -0500
@@ -8,7 +8,7 @@
 ################################################################################
 from mud import *
 from mudsys import add_cmd, add_cmd_check
-import inform, hooks
+import inform, hooks, mudsock, history
 
 
 
@@ -22,7 +22,7 @@
        '''
     try:
         tgt, question = parse_args(ch, True, cmd, arg,
-                                   "ch.room.noself [about] string")
+                                   "ch.room.noself [about] string(question)")
     except: return
 
     question = question.replace("$", "$$")
@@ -39,16 +39,21 @@
 
        This command sends a message to another character. Primarily intended
        for player-to-player communication. Players can tell other players
-       things even if they are not in the same room.'''
+       things even if they are not in the same room.
+
+       see also: reply'''
     try:
-        tgt, mssg = parse_args(ch, True, cmd, arg, "ch.world.noself string")
+        tgt, mssg = parse_args(ch, True, cmd, arg, "ch.world.noself string(message)")
     except: return
 
-    mssg = mssg.replace("$", "$$")
-    message(ch, tgt, None, None, False, "to_vict",
-            "{r$n tells you, '" + mssg + "'{n")
-    message(ch, tgt, None, None, False, "to_char",
-            "{rYou tell $N, '" + mssg + "'{n")
+    mssg   = mssg.replace("$", "$$")
+    tovict = "{r$n tells you, '" + mssg + "'{n"
+    toch   = "{rYou tell $N, '" + mssg + "'{n"
+    message(ch, tgt, None, None, False, "to_vict", tovict)
+    message(ch, tgt, None, None, False, "to_char", toch)
+    history.add_history(ch,   "tell", "{r%-10s: %s{n" % (ch.name, mssg))
+    history.add_history(tgt,  "tell", "{r%-10s: %s{n" % (ch.name, mssg))
+    hooks.run("tell", hooks.build_info("ch ch", (ch, tgt)))
 
 def cmd_chat(ch, cmd, arg):
     '''Usage: chat <message>
@@ -58,11 +63,20 @@
     if arg == '':
         ch.send("Chat what?")
     else:
-        arg = arg.replace("$", "$$")
-        message(ch, None, None, None, False, "to_world",
-                "{y$n chats, '" + arg + "'{n")
-        message(ch, None, None, None, False, "to_char",
-                "{yyou chat, '" + arg + "'{n")
+        arg  = arg.replace("$", "$$")
+        mssg = "{y$n chats, '" + arg + "'{n"
+        message(ch, None, None, None, False, "to_world", mssg)
+        message(ch, None, None, None,False,"to_char", "{yyou chat, '"+arg+"'{n")
+        history.add_history(ch, "chat", "{y%-10s: %s{n" % (ch.name, arg))
+
+def cmd_wiz(ch, cmd, arg):
+    if arg == '':
+        ch.send("WizChat what?")
+    else:
+        mssg = "{b%s WizChats, '{c%s{b'{n" % (ch.name, arg)
+        for sock in mudsock.socket_list():
+            if sock.ch != None and sock.ch.isInGroup("wizard"):
+                sock.ch.send(mssg)
 
 def cmd_say(ch, cmd, arg):
     '''Usage: say <message>
@@ -95,7 +109,8 @@
     message(ch, tgt, None, None, False, "to_room", "$n greets $N.")
 
     # run greet hooks
-    hooks.run("greet", hooks.build_info("ch ch", (ch, tgt)))
+    hooks.run("greet",      hooks.build_info("ch ch", (ch, tgt)))
+    hooks.run("post_greet", hooks.build_info("ch ch", (ch, tgt)))
 
 def cmd_emote(ch, cmd, arg):
     '''Usage: emote <text>
@@ -138,10 +153,10 @@
        anyone in the mud, regardless if you are in the same room as them or not.
        '''
     try:
-        tgt, mssg = parse_args(ch, True, cmd, arg, "ch.world.noself string")
+        tgt, mssg = parse_args(ch, True, cmd, arg, "ch.world.noself string(message)")
     except: return
-    ch.send("\007\007You page " + inform.see_char_as(ch, tgt))
-    tgt.send("\007\007*" + inform.see_char_as(tgt, ch) + "* " + mssg)
+    ch.send("\007\007You page " + ch.see_as(tgt))
+    tgt.send("\007\007*" + tgt.see_as(ch) + "* " + mssg)
 
 
 
@@ -153,6 +168,7 @@
 add_cmd("'",       None, cmd_say,   "player", False)
 add_cmd("tell",    None, cmd_tell,  "player", False)
 add_cmd("chat",    None, cmd_chat,  "player", False)
+add_cmd("wizchat", "wiz",cmd_wiz,   "wizard", False)
 add_cmd("gossip",  None, cmd_chat,  "player", False)
 add_cmd("\"",      None, cmd_chat,  "player", False)
 add_cmd("page",    None, cmd_page,  "player", False)
@@ -163,9 +179,14 @@
 add_cmd(":",       None, cmd_emote, "player", False)
 
 def chk_room_communication(ch, cmd):
-    if ch.pos in ["sleeping", "unconscious"]:
+    if ch.pos in ("sleeping", "unconscious"):
         ch.send("You cannot do that while " + ch.pos + ".")
         return False
 
 for cmd in ["ask", "say", "'", "greet", "approach", "emote", ":"]:
     add_cmd_check(cmd, chk_room_communication)
+
+# register our history handling
+history.register_comm_history("chat", lambda ch: "chat")
+# history.register_comm_history("say",  lambda ch: ch.name)
+history.register_comm_history("tell", lambda ch: ch.name)
diff -ruN ../nakedmudv3.7/lib/pymodules/cmd_inform.py lib/pymodules/cmd_inform.py
--- ../nakedmudv3.7/lib/pymodules/cmd_inform.py	2008-05-31 00:18:11.000000000 -0400
+++ lib/pymodules/cmd_inform.py	2009-03-02 02:38:42.000000000 -0500
@@ -21,11 +21,10 @@
     if len(ch.inv) == 0:
         ch.send("You are not carrying anything.")
     else:
-        ch.send("{gYou are carrying:")
+        ch.send("You are carrying:")
         visible = utils.find_all_objs(ch, ch.inv, "", None, True)
         utils.show_list(ch, visible, lambda(x): x.name, lambda(x): x.mname)
 
-
 def cmd_equipment(ch, cmd, arg):
     '''Displays all of the equipment you are currently wearing.'''
     ch.send("You are wearing:")
@@ -33,7 +32,7 @@
 
 def cmd_who(ch, cmd, arg):
     '''List all of the players currently online.'''
-    ch.page(build_who())
+    ch.page(build_who(ch))
     
 def cmd_look(ch, cmd, arg):
     '''allows players to examine just about anything in the game'''
@@ -62,7 +61,7 @@
 ################################################################################
 # add our commands
 ################################################################################
-add_cmd("inventory", "inv", cmd_inventory, "player", False)
+add_cmd("inventory", "i",   cmd_inventory, "player", False)
 add_cmd("equipment", "eq",  cmd_equipment, "player", False)
 add_cmd("worn",      None,  cmd_equipment, "player", False)
 add_cmd("who",       None,  cmd_who,       "player", False)
diff -ruN ../nakedmudv3.7/lib/pymodules/cmd_manip.py lib/pymodules/cmd_manip.py
--- ../nakedmudv3.7/lib/pymodules/cmd_manip.py	2008-12-06 00:20:20.000000000 -0500
+++ lib/pymodules/cmd_manip.py	2009-03-02 02:02:41.000000000 -0500
@@ -59,15 +59,15 @@
 def do_get(ch, obj, cont):
     '''transfers an item from the ground to the character'''
     if is_keyword(obj.bits, "notake"):
-        ch.send("You cannot take " + see_obj_as(ch, obj) + ".")
+        ch.send("You cannot take " + ch.see_as(obj) + ".")
     elif cont != None:
+        obj.carrier = ch
         message(ch, None, obj, cont, True, "to_char", "You get $o from $O.")
         message(ch, None, obj, cont, True, "to_room", "$n gets $o from $O.")
-        obj.carrier = ch
     else:
+        obj.carrier = ch
         message(ch, None, obj, None, True, "to_char", "You get $o.")
         message(ch, None, obj, None, True, "to_room", "$n gets $o.")
-        obj.carrier = ch
 
         # run get hooks
         hooks.run("get", hooks.build_info("ch obj", (ch, obj)))
@@ -88,9 +88,13 @@
             for obj in list:
                 do_get(ch, obj, cont)
         else:
-            obj = find_obj(ch, cont.objs, num, name)
+            # obj = find_obj(ch, cont.objs, num, name)
+            obj = mudobj.find_obj(arg, cont, ch)
             if obj != None:
                 do_get(ch, obj, cont)
+            else:
+                message(ch, None, cont, None, True, "to_char",
+                        "You could not find what you were looking for in $o.")
 
 def cmd_get(ch, cmd, arg):
     '''Usage: get [the] <item> [[from] <other item>]
@@ -100,7 +104,7 @@
        instead tries to move an object from the container to your inventory.'''
     try:
         arg, cont = parse_args(ch, True, cmd, arg,
-                               "[the] word | [from] obj.room.inv.eq")
+                               "[the] word(object) | [from] obj.room.inv.eq")
     except: return
     
     # are we doing get, or get-from?
@@ -121,9 +125,10 @@
 
 def do_drop(ch, obj):
     '''handles object dropping'''
+    obj.room = ch.room
+
     message(ch, None, obj, None, True, "to_char", "You drop $o.")
     message(ch, None, obj, None, True, "to_room", "$n drops $o.")
-    obj.room = ch.room
 
     # run our drop hook
     hooks.run("drop", hooks.build_info("ch obj", (ch, obj)))
@@ -150,7 +155,7 @@
 
     # make sure it succeeded
     if obj.carrier != ch:
-        ch.send("You were unable to remove " + see_obj_as(ch, obj) + ".")
+        ch.send("You were unable to remove " + ch.see_as(obj) + ".")
     else:
         message(ch, None, obj, None, True, "to_char", "You remove $o.")
         message(ch, None, obj, None, True, "to_room", "$n removes $o.")
@@ -189,15 +194,14 @@
 def do_wear(ch, obj, where):
     '''handles object wearing'''
     if not obj.istype("worn"):
-        ch.send("But " + see_obj_as(ch, obj) + " is not wearable.")
+        ch.send("But " + ch.see_as(obj) + " is not equippable.")
+        
     elif ch.equip(obj, where):
         message(ch, None, obj, None, True, "to_char", "You wear $o.")
         message(ch, None, obj, None, True, "to_room", "$n wears $o.")
 
         # run our wear hook
         hooks.run("wear", hooks.build_info("ch obj", (ch, obj)))
-    else:
-        message(ch, None, obj, None, True, "to_char", "You could not equip $o.")
 
 def cmd_wear(ch, cmd, arg):
     '''Usage: wear <item> [where]
@@ -215,9 +219,20 @@
        > wear gloves left hand, right hand'''
     try:
         found, multi, where = parse_args(ch, True, cmd, arg,
-                                         "[the] obj.inv.multiple | [on] string")
+                                         "[the] obj.inv.multiple | [on] string(bodyparts)")
     except: return
 
+    # Are the things we're looking for not body positions? Try to catch this!
+    # it will happen when someone enters multiple arguments for the name without
+    # supplying ' and ' around it. The mud will misinterpret it as an item
+    if not multi and where != None and not "," in where:
+        # reparse what we want!
+        if not where in ch.bodyparts:
+            where = None
+            try:
+                found, = parse_args(ch,True,cmd,"'"+arg+"'","[the] obj.inv")
+            except: return
+
     # are we wearing one thing, or multiple things?
     if multi == False:
         do_wear(ch, found, where)
@@ -228,11 +243,11 @@
 def do_put(ch, obj, cont):
     '''handles the putting of objects'''
     if obj == cont:
-        ch.send("You cannot put " + see_obj_as(ch, obj) + " into itself.")
+        ch.send("You cannot put " + ch.see_as(obj) + " into itself.")
     # make sure we have enough room 
     elif obj.weight > cont.container_capacity - cont.weight + cont.weight_raw:
-        ch.send("There is not enough room in " + see_obj_as(ch, cont) +
-                " for " + see_obj_as(ch, obj) + ".")
+        ch.send("There is not enough room in " + ch.see_as(cont) +
+                " for " + ch.see_as(obj) + ".")
     # do the move
     else:
         obj.container = cont
@@ -248,14 +263,14 @@
     try:
         found, multi, cont = parse_args(ch, True, cmd, arg,
                                         "[the] obj.inv.multiple " +
-                                        "[in the] obj.room.inv")
+                                        "[in] [the] obj.room.inv")
     except: return
 
     # make sure we have a container
     if not cont.istype("container"):
-        ch.send(see_obj_as(ch, cont) + " is not a container.")
+        ch.send(ch.see_as(cont) + " is not a container.")
     elif cont.container_is_closed:
-        ch.send(see_obj_as(ch, cont) + " is currently closed.")
+        ch.send(ch.see_as(cont) + " is currently closed.")
     # do we have one or multiple items?
     elif multi == False:
         do_put(ch, found, cont)
@@ -306,6 +321,9 @@
         elif not locked and opp_ex.is_locked:
             opp_ex.unlock()
             ex.dest.send(name + " unlocks from the other side.")
+        else:
+            return
+        # hooks.run("room_change", hooks.build_info("rm", (opp_ex.room, )))
 
 def cmd_lock(ch, cmd, arg):
     '''Usage: lock <direction | door | container>
@@ -319,33 +337,38 @@
     # what did we find?
     if type == "exit":
         ex = found
+        name = ex.name
+        if ex.name == "":
+            name = "the exit"
+        
         if not ex.is_closed:
-            ch.send(ex.name + " must be closed first.")
+            ch.send(name + " must be closed first.")
         elif ex.is_locked:
-            ch.send(ex.name + " is already locked.")
+            ch.send(name + " is already locked.")
         elif ex.key == '':
-            ch.send("You cannot figure out how " + ex.name +" would be locked.")
+            ch.send("You cannot figure out how " + name +" would be locked.")
         elif not has_proto(ch, ex.key):
             ch.send("You cannot seem to find the key.")
         else:
             message(ch, None, None, None, True, "to_char",
-                    "You lock " + ex.name + ".")
+                    "You lock " + name + ".")
             message(ch, None, None, None, True, "to_room",
-                    "$n locks " + ex.name + ".")
+                    "$n locks " + name + ".")
             ex.lock()
+            # hooks.run("room_change", hooks.build_info("rm", (ch.room, )))
             try_manip_other_exit(ch.room, ex, ex.is_closed, True)
 
     # type must be object
     else:
         obj = found
         if not obj.istype("container"):
-            ch.send(see_obj_as(ch, obj) + " is not a container.")
+            ch.send(ch.see_as(obj) + " is not a container.")
         elif not obj.container_is_closed:
-            ch.send(see_obj_as(ch, obj) + " is not closed.")
+            ch.send(ch.see_as(obj) + " is not closed.")
         elif obj.container_is_locked:
-            ch.send(see_obj_as(ch, obj) + " is already locked.")
+            ch.send(ch.see_as(obj) + " is already locked.")
         elif obj.container_key == '':
-            ch.send("You cannot figure out how to lock " + see_obj_as(ch, obj))
+            ch.send("You cannot figure out how to lock " + ch.see_as(obj))
         elif not has_proto(ch, obj.container_key):
             ch.send("You cannot seem to find the key.")
         else:
@@ -364,34 +387,39 @@
     # what did we find?
     if type == "exit":
         ex = found
+        name = ex.name
+        if ex.name == "":
+            name = "the exit"
+        
         if not ex.is_closed:
-            ch.send(ex.name + " is already open.")
+            ch.send(name + " is already open.")
         elif not ex.is_locked:
-            ch.send(ex.name + " is already unlocked.")
+            ch.send(name + " is already unlocked.")
         elif ex.key == '':
-            ch.send("You cannot figure out how " + ex.name +
+            ch.send("You cannot figure out how " + name +
                     " would be unlocked.")
         elif not has_proto(ch, ex.key):
             ch.send("You cannot seem to find the key.")
         else:
             message(ch, None, None, None, True, "to_char",
-                    "You unlock " + ex.name + ".")
+                    "You unlock " + name + ".")
             message(ch, None, None, None, True, "to_room",
-                    "$n unlocks " + ex.name + ".")
+                    "$n unlocks " + name + ".")
             ex.unlock()
+            # hooks.run("room_change", hooks.build_info("rm", (ch.room, )))
             try_manip_other_exit(ch.room, ex, ex.is_closed, False)
 
     # must be an object
     else:
         obj = found
         if not obj.istype("container"):
-            ch.send(see_obj_as(ch, obj) + " is not a container.")
+            ch.send(ch.see_as(obj) + " is not a container.")
         elif not obj.container_is_closed:
-            ch.send(see_obj_as(ch, obj) + " is already open.")
+            ch.send(ch.see_as(obj) + " is already open.")
         elif not obj.container_is_locked:
-            ch.send(see_obj_as(ch, obj) + " is already unlocked.")
+            ch.send(ch.see_as(obj) + " is already unlocked.")
         elif obj.container_key == '':
-            ch.send("You cannot figure out how to unlock "+see_obj_as(ch, obj))
+            ch.send("You cannot figure out how to unlock "+ ch.see_as(obj))
         elif not has_proto(ch, obj.container_key):
             ch.send("You cannot seem to find the key.")
         else:
@@ -410,18 +438,23 @@
     # is it an exit?
     if type == "exit":
         ex = found
+        name = ex.name
+        if name == "":
+            name = "the exit"
+        
         if not ex.is_closed:
-            ch.send(ex.name + " is already open.")
+            ch.send(name + " is already open.")
         elif ex.is_locked:
-            ch.send(ex.name + " must be unlocked first.")
+            ch.send(name + " must be unlocked first.")
         elif not ex.is_closable:
-            ch.send(ex.name + " cannot be opened.")
+            ch.send(name + " cannot be opened.")
         else:
             message(ch, None, None, None, True, "to_char",
-                    "You open " + ex.name + ".")
+                    "You open " + name + ".")
             message(ch, None, None, None, True, "to_room",
-                    "$n opens " + ex.name + ".")
+                    "$n opens " + name + ".")
             ex.open()
+            # hooks.run("room_change", hooks.build_info("rm", (ch.room, )))
             try_manip_other_exit(ch.room, ex, False, ex.is_locked)
             hooks.run("open_door", hooks.build_info("ch ex", (ch, ex)))
 
@@ -429,13 +462,13 @@
     else:
         obj = found
         if not obj.istype("container"):
-            ch.send(see_obj_as(ch, obj) + " is not a container.")
+            ch.send(ch.see_as(obj) + " is not a container.")
         elif not obj.container_is_closed:
-            ch.send(see_obj_as(ch, obj) + " is already open.")
+            ch.send(ch.see_as(obj) + " is already open.")
         elif obj.container_is_locked:
-            ch.send(see_obj_as(ch, obj) + " must be unlocked first.")
+            ch.send(ch.see_as(obj) + " must be unlocked first.")
         elif not obj.container_is_closable:
-            ch.send(see_obj_as(ch, obj) + " cannot be opened.")
+            ch.send(ch.see_as(obj) + " cannot be opened.")
         else:
             message(ch, None, obj, None, True, "to_char", "You open $o.")
             message(ch, None, obj, None, True, "to_room", "$n opens $o.")
@@ -453,33 +486,40 @@
     # is it an exit?
     if type == "exit":
         ex = found
+        name = ex.name
+        if name == "":
+            name = "the exit"
+
         if ex.is_closed:
-            ch.send(ex.name + " is already closed.")
+            ch.send(name + " is already closed.")
         elif ex.is_locked:
-            ch.send(ex.name + " must be unlocked first.")
+            ch.send(name + " must be unlocked first.")
         elif not ex.is_closable:
-            ch.send(ex.name + " cannot be closed.")
+            ch.send(name + " cannot be closed.")
         else:
             message(ch, None, None, None, True, "to_char",
-                    "You close " + ex.name + ".")
+                    "You close " + name + ".")
             message(ch, None, None, None, True, "to_room",
-                    "$n closes " + ex.name + ".")
+                    "$n closes " + name + ".")
             ex.close()
+            # hooks.run("room_change", hooks.build_info("rm", (ch.room, )))
             try_manip_other_exit(ch.room, ex, True, ex.is_locked) 
+            hooks.run("open_door", hooks.build_info("ch ex", (ch, ex)))
 
     # must be an object
     else:
         obj = found
         if not obj.istype("container"):
-            ch.send(see_obj_as(ch, obj) + " is not a container.")
+            ch.send(ch.see_as(obj) + " is not a container.")
         elif obj.container_is_closed:
-            ch.send(see_obj_as(ch, obj) + " is already closed.")
+            ch.send(ch.see_as(obj) + " is already closed.")
         elif not obj.container_is_closable:
-            ch.send(see_obj_as(ch, obj) + " cannot be closed.")
+            ch.send(ch.see_as(obj) + " cannot be closed.")
         else:
             message(ch, None, obj, None, True, "to_char", "You close $o.")
             message(ch, None, obj, None, True, "to_room", "$n closes $o.")
             obj.container_is_closed = True
+            hooks.run("close_obj", hooks.build_info("ch obj", (ch, obj)))
 
 
 
diff -ruN ../nakedmudv3.7/lib/pymodules/cmd_misc.py lib/pymodules/cmd_misc.py
--- ../nakedmudv3.7/lib/pymodules/cmd_misc.py	2008-05-31 00:18:11.000000000 -0400
+++ lib/pymodules/cmd_misc.py	2009-03-02 01:45:15.000000000 -0500
@@ -54,8 +54,11 @@
 def cmd_save(ch, cmd, arg):
     '''Attempt to save your character and all recent changes made to it, to
        disk. This automatically happens when logging out.'''
-    mudsys.do_save(ch)
-    ch.send("Saved.")
+    if mudsys.do_save(ch):
+        ch.send("Saved.")
+    else:
+        ch.send("Your character was not saved.")
+    
 
 def cmd_quit(ch, cmd, arg):
     '''Attempts to save and log out of the game.'''
@@ -75,6 +78,6 @@
 add_cmd("save",  None, cmd_save,  "player", False)
 add_cmd("quit",  None, cmd_quit,  "player", True)
 
-chk_can_save = lambda ch, cmd: ch.is_pc
+chk_can_save = lambda ch, cmd: not ch.is_npc
 add_cmd_check("save", chk_can_save)
 add_cmd_check("quit", chk_can_save)
diff -ruN ../nakedmudv3.7/lib/pymodules/colour.py lib/pymodules/colour.py
--- ../nakedmudv3.7/lib/pymodules/colour.py	2008-05-31 00:18:11.000000000 -0400
+++ lib/pymodules/colour.py	2009-03-02 01:45:15.000000000 -0500
@@ -10,7 +10,7 @@
 
 # symbols and values we need for processing colours
 base_colour_marker   = '{'
-colour_start         = '\x1B['
+colour_start         = '\x1b['
 cDARK                = '0'
 cLIGHT               = '1'
 
diff -ruN ../nakedmudv3.7/lib/pymodules/history.py lib/pymodules/history.py
--- ../nakedmudv3.7/lib/pymodules/history.py	1969-12-31 19:00:00.000000000 -0500
+++ lib/pymodules/history.py	2009-03-02 01:45:15.000000000 -0500
@@ -0,0 +1,82 @@
+'''
+history.py
+
+a little database module for storing communication histories. Can store by
+arbitrary groupings e.g., for guild, global, zone, or personal communications.
+'''
+import mudsys
+
+
+
+################################################################################
+# local variables
+################################################################################
+
+# our table that maps communication type to a second table of groupings and
+# grouping functions
+comm_table = { }
+
+# what is the maximum length of our history logs
+MAX_HISTORY_LEN = 20
+
+
+
+################################################################################
+# history functions
+################################################################################
+def register_comm_history(type, group_func):
+    '''register a new type of history, and add a grouping function as well.'''
+    if not type in comm_table:
+        comm_table[type] = (group_func, { })
+
+def get_history(ch, type):
+    '''return the communication history for a character.'''
+    group_func, table = comm_table[type]
+    key = group_func(ch)
+    if not key in table:
+        return [ ]
+    return table[key]
+
+def add_history(ch, type, mssg):
+    group_func, table = comm_table[type]
+    key = group_func(ch)
+    if key != None:
+        if not key in table:
+            table[key] = [ ]
+        table[key].append(mssg)
+
+        # make sure we don't get too big
+        while len(table[key]) > MAX_HISTORY_LEN:
+            table[key].pop(0)
+
+
+
+################################################################################
+# commands
+################################################################################
+def cmd_history(ch, cmd, arg):
+    '''Communication logs are stored as you receive communication. To review
+       communication you have used, you can use the history command.'''
+    arg = arg.lower()
+    if arg == "":
+        opts = comm_table.keys()
+        opts.sort()
+        ch.send("History logs available to you are:")
+        ch.send("  " + ", ".join(opts))
+    elif not arg in comm_table:
+        ch.send("There is no history log for that type of communication.")
+    else:
+        group_func, table = comm_table[arg]
+        key = group_func(ch)
+
+        if not key in table:
+            ch.send("Your history is empty.")
+        else:
+            ch.page("\r\n".join(table[key]) + "\r\n")
+
+
+
+################################################################################
+# initialization
+################################################################################
+mudsys.add_cmd("history", None, cmd_history, "player", False)
